=== debian/changelog ===
nootka (0.8.77-0ubuntu1) saucy; urgency=low

  * New upstream release.
    - Now requires libvorbis-dev, libsoundtouch0, libpulse0, libjack0

 -- Jackson Doak <noskcaj@ubuntu.com>  Wed, 10 Jul 2013 16:53:46 +1000
