=== debian/control ===
Source: nootka
Section: sound
Priority: extra
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Howard Chan <smartboyhw@gmail.com>
Build-Depends: debhelper (>= 8.0.0), cmake, pkg-kde-tools, libqt4-dev, qtmobility-dev, libfftw3-dev, libasound2-dev, libvorbis-dev, libsoundtouch-dev, libpulse-dev, libjack-dev
Standards-Version: 3.9.4
Homepage: http://nootka.sourceforge.net/
#Vcs-Git: git://git.debian.org/collab-maint/nootka.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/nootka.git;a=summary

Package: nootka
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: This package nootka provides an application to learn classical score notation.
 Nootka is an application to learn classical score notation.
 It helps to understand the rules of reading and writing scores
 and develops skills for playing and singing notes.
